#!/bin/bash

#echo ${rootmnt}

critical_list=( \
  "libc6" "libc-dev-bin" "kylin-activation" "kyactivation" \
  "libkylin-activation" \
  "dpkg"
)

core_list=(    \                 
   "libxml2"  "zlib1g"  \
   "libpam0g" "libglib2.0-0"  "libpng16-16" "ibpng12-0"  \
   "libglx0"  "libstdc++6" "libqt5core5a"  "libuuid1" \
   "libsqlite3-0" "libjpeg-turbo8" "openssl"  "libgcc-s1" \
   "libaio1" "libgtk-3-0"  "libkrb5-3" "libgomp1" \
   "python3.8" "libatomic1"  "libselinux1" "libgpg-error0" \
   "libxdmcp6" "liblzma5"  "fontconfig" "libgcrypt20" \
   "libxcb1" "libcap-ng0"  "libx11-6" "gnupg" \
   "libncurses5" "bzip2" "libcurl4" "libnotify4" "libsdl2-2.0-0" \
   "alsa-base" "libreadline8" "libdrm2" "libpango-1.0-0" \
   "libcrypt1" "libaudit1" "libgnutls30" "libgmp10" \
   "libacl1" "libfreetype6" "libexpat1" "libtiff5" \
   "libgdk-pixbuf2.0-0" "libcom-err2" "libpulse0" \
   "libcairo2" "libasound2" "libxinerama1" "libpixman-1-0" \
   "libqt5widgets5" "libqt5gui5" "libqt5dbus5" "libqt5core5a" \
   "libglu1-mesa" "ffmpeg" "libvdpau1" "libva2"
)

special_shell_list=( \
   "/usr/bin/kylin-system-verify-legacy" \
   "/usr/bin/kylin-system-verify-new" \
   "/usr/bin/kylin-system-verify" \ 
   "/usr/bin/core-file-lock.sh" \
   "/usr/bin/kylin-anti.sh" \
   "/usr/bin/sprof" \
   "/usr/bin/gencat" \
   "/usr/bin/rpcgen" \
   "/usr/bin/mtrace" \
   "/usr/bin/sotruss"
)

os_release_list=( \
  "/etc/os-release" \
  "/etc/os-release-variant"
)

function files_append {
  for element in ${critical_list[@]}
  do
    echo $element
    ${rootmnt}/usr/bin/kylin-anti.sh append_attr $element
  done

  for ele in ${os_release_list[@]}
  do
    ${rootmnt}/usr/bin/chattr +i ${ele}
  done
}

function files_remove {
  for element in ${critical_list[@]}
  do
    echo $element
    ${rootmnt}/usr/bin/kylin-anti.sh remove_attr $element
  done

  for ele in ${os_release_list[@]}
  do
    ${rootmnt}/usr/bin/chattr -i $ele
  done
}

output_file=${rootmnt}/var/lib/dpkg/lock-files.list
tmp_file=${rootmnt}/var/lib/dpkg/tmp-lock-files.list

function files_remove_rootmnt {
  files_list_rootmn=$(cat $tmp_file)
  for element in ${files_list_rootmn}
  do  
  #  echo $element
    ${rootmnt}/usr/bin/chattr -i $element
  done

  # if [ "$@" == "libkylin-activation" ]; then
  #     ${rootmnt}/usr/bin/chattr -i "${rootmnt}/usr/bin/kylin-system-verify-new"
  #     ${rootmnt}/usr/bin/chattr -i "${rootmnt}/usr/bin/kylin-system-verify-legacy"
  # fi
  # if [ "$@" == "dpkg" ]; then
  #     ${rootmnt}/usr/bin/chattr -i "${rootmnt}/usr/bin/core-file-lock.sh"
  #     ${rootmnt}/usr/bin/chattr -i "${rootmnt}/usr/bin/kylin-anti.sh"
  # fi
}

function files_append_rootmnt {
  files_list_rootmn=$(cat $tmp_file)
  for element in ${files_list_rootmn}
  do  
  #  echo $element
    ${rootmnt}/usr/bin/chattr +i $element
  done

  # if [ "$@" == "libkylin-activation" ]; then
  #     ${rootmnt}/usr/bin/chattr +i "${rootmnt}/usr/bin/kylin-system-verify-new"
  #     ${rootmnt}/usr/bin/chattr +i "${rootmnt}/usr/bin/kylin-system-verify-legacy"
  # fi
  # if [ "$@" == "dpkg" ]; then
  #     ${rootmnt}/usr/bin/chattr +i "${rootmnt}/usr/bin/core-file-lock.sh"
  #     ${rootmnt}/usr/bin/chattr +i "${rootmnt}/usr/bin/kylin-anti.sh"
  # fi
}
    
function files_output {
  if [ -f $output_file ] 
  then
    rm  ${output_file}
  fi

  ${rootmnt}/usr/bin/touch $output_file

  for element in ${critical_list[@]}
  do
#    echo $element
    files=:$(${rootmnt}/usr/bin/dpkg-query --listfiles $element)   
    for m_file in $files
      do 
	if [ -f "$m_file" ]
	then
	  if [ `file $m_file | grep -E 'ELF|text executable' | wc -l` != "0" ]
          then
            echo "$m_file" >> ${output_file}
	  fi
	fi
      done
  done

  rm $tmp_file
  ${rootmnt}/usr/bin/touch $tmp_file

  files_list=$(cat $output_file)
  for m_file in $files_list
  do
    echo "/root${m_file}" >> $tmp_file
  done

  for ele in ${special_shell_list[@]}
  do
    echo "/root${ele}" >> $tmp_file    
  done

  for ele in ${os_release_list[@]}
  do
    echo "/root${ele}" >> $tmp_file
  done
}

if [ "$1" == "append" ]; then
  output_attr=$(lsattr $output_file)
  #通过判断是否有i标志区分是否打过标记，打过标记的就没有必要再打标记了
  if [[ $output_attr == *"i----"* ]]; then
    echo $output_attr
    files_list=$(cat $output_file)
    for m_file in $files_list
    do
      if [[ $m_file != *"i----"* ]]; then
        /usr/bin/chattr +i $m_file
      fi
    done
  else
    echo $output_attr
    echo "files_append begin"
    files_append
    /usr/bin/chattr -i $output_file
    files_output
    /usr/bin/chattr +i $output_file
    echo "files_append done"
  fi
elif [ "$1" == "remove" ]; then
  files_remove
elif [ "$1" == "output" ]; then
  files_output
elif [ "$1" == "rootremove" ]; then
  files_remove_rootmnt
elif [ "$1" == "rootappend" ]; then
  files_append_rootmnt
else
    echo "未知参数"
fi



